import sys

def main(argv=None):
    if not argv:
        argv = sys.argv

    if len(argv) < 4:
        print "usage: python %s bins percent infile" % sys.argv[0]
        sys.exit(1)

    bins = int(argv[1])
    percent = int(argv[2])
    infilename = argv[3]

    printCdfDist(bins, percent, infilename)


def printCdfDist(bins, percent, infilename):
    print cdfDist(bins, percent, infilename)


def cdfDist(bins, percent, infilename):
    infile = open(infilename)
    binsList = [0] * bins

    for line in infile:
        fields = line.strip().split()
        index = 0
        for binCdf in fields[-1 * bins:]:
            if int(binCdf) > percent:
                binsList[index] += 1
                break

            index += 1

    infile.close()
    return binsList


if __name__ == "__main__":
    main(sys.argv)