import sys

def main(argv=None):
    if not argv:
        argv = sys.argv

    print "colsum: version 1.3"
    if len(argv) < 3:
        print "usage: python %s field filename" % argv[0]
        print "\n\tfields are counted starting at zero.\n"
        sys.exit(1)

    fieldID = int(argv[1])
    filename = argv[2]

    count = colsum(fieldID, filename)
    print count


def colsum(fieldID, filename):
    infile = open(filename)
    count = 0

    for line in infile:
        fields = line.strip().split()
        try:
            if "." in fields[fieldID]:
                count += float(fields[fieldID])
            else:
                count += int(fields[fieldID])
        except (ValueError, IndexError):
            pass

    infile.close()
    return count


if __name__ == "__main__":
    main(sys.argv)